#!/usr/bin/perl
use strict;
use warnings;
use Getopt::Long;

my ($f,$minLOH,$minSNPs);
$minLOH = 30.0;
$minSNPs = 2;
GetOptions (
  "f=s" => \$f,
  "minLOH=s" => \$minLOH,
  "minSNPs=i" => \$minSNPs,
);
$minLOH += 0;

my $LOH_Score_Col = 7; # 0 based

my ($li,@li,@k,$c,$p,$v,$c_,$p_,$v_);
$c_ = "@";
$p_ = "#";
$v_ = -1;
my @region = ();
my $n = 0;
open(F,$f)||die;
while ($li=<F>) {
    chomp $li;
    if ($li =~ /^#/) { next; }
    @li = split(/\t/,$li);
    @k = split(/\:/,$li[0]);
    $c = $k[0];
    $p = $k[1];
    if ($li[$LOH_Score_Col] >= $minLOH) {
        $v = 1;
    } else {
        $v = 0;
    }
    if ($v != $v_) {
        if ($c eq $c_) {
            # 1 x 0.8
            # 1 y 0
            my %se = ();
            $n++;
            $region[$n-1] = \%se;
            $region[$n-1]->{"start"} = $li[0];
            $region[$n-1]->{"end"} = $li[0];
            $region[$n-1]->{"isLOH"} = $v;
        } else {
            # 1 x 0.8
            # 2 y 0
            my %se = ();
            $n++;
            $region[$n-1] = \%se;
            $region[$n-1]->{"start"} = $li[0];
            $region[$n-1]->{"end"} = $li[0];
            $region[$n-1]->{"isLOH"} = $v;
        }
    } else {
        if ($c eq $c_) {
            # 1 x 0
            # 1 y 0
            $region[$n-1]->{"end"} = $li[0];
            $region[$n-1]->{"isLOH"} += $v;
        } else {
            # 1 x 0
            # 2 y 0
            my %se = ();
            $n++;
            $region[$n-1] = \%se;
            $region[$n-1]->{"start"} = $li[0];
            $region[$n-1]->{"end"} = $li[0];
            $region[$n-1]->{"isLOH"} = $v;
        }
    }
    #print $region[$n-1]->{"start"},"  ",$region[$n-1]->{"end"},"  ",$region[$n-1]->{"isLOH"},"\n";
    $c_ = $c;
    $p_ = $p;
    $v_ = $v;
}
close F;

my $w = $f.".LOH.".$minLOH.".SNPs.".$minSNPs.".txt";
open(W,">$w")||die"$!";
print W "#region\tnSNPs\tregionLength\n";
my ($i,$start,$end,@start,@end,$isLOH,$regionL);
for ($i=0;$i<@region;$i++) {
    @start = split(/\:/,$region[$i]->{"start"});
    @end   = split(/\:/,$region[$i]->{"end"});
    $start = $start[1];
    $end   = $end[1];
    $isLOH = $region[$i]->{"isLOH"};
    $regionL = $end - $start + 1;
    if ($isLOH >= $minSNPs) {
        #print $start[0],":",$start,"-",$end,"\t",$isLOH,"(SNPs)\t",$regionL,"(bp)\n";
        print W $start[0],":",$start,"-",$end,"\t",$isLOH,"\t",$regionL,"\n";
    }
}
close W;
